//
//  COXRoundFlowLayout.m
//  COXRoundFlowLayout
//
//  Created by ios on 2018/1/16.
//  Copyright © 2018年 ios. All rights reserved.
//

#import "COXRoundFlowLayout.h"

@interface COXRoundFlowLayout()
@property (nonatomic, assign) CGPoint roundCenter;
@property (nonatomic, assign) CGFloat roundRadius;
@property (nonatomic, assign) NSInteger totalNum;
@property (nonatomic, strong) NSMutableArray *layoutAttributes;
@end

@implementation COXRoundFlowLayout

#pragma mark - override
- (void)prepareLayout {
    [super prepareLayout];
    [self.layoutAttributes removeAllObjects];
    self.roundCenter = CGPointMake(CGRectGetWidth(self.collectionView.bounds) / 2.0, CGRectGetHeight(self.collectionView.bounds) / 2.0);
    self.roundRadius = (MIN(CGRectGetWidth(self.collectionView.bounds), CGRectGetHeight(self.collectionView.bounds)) - 90) / 2.0f;
    self.totalNum = [self.collectionView numberOfItemsInSection:0];
    for (NSInteger i = 0; i < self.totalNum; i++) {
        NSIndexPath *index = [NSIndexPath indexPathForRow:i inSection:0];
        UICollectionViewLayoutAttributes *attribute = [self layoutAttributesForItemAtIndexPath:index];
        [self.layoutAttributes addObject:attribute];
    }
}

- (UICollectionViewLayoutAttributes *)layoutAttributesForItemAtIndexPath:(NSIndexPath *)indexPath {
    UICollectionViewLayoutAttributes *att = [UICollectionViewLayoutAttributes layoutAttributesForCellWithIndexPath:indexPath];
    att.size = CGSizeMake(60, 60);
    CGFloat angle = 2 * M_PI * indexPath.row / self.totalNum ;
    att.center = CGPointMake(self.roundCenter.x + self.roundRadius * cos(angle), self.roundCenter.y + self.roundRadius * sin(angle));
    return att;
}

- (NSArray<UICollectionViewLayoutAttributes *> *)layoutAttributesForElementsInRect:(CGRect)rect
{
    return self.layoutAttributes;
}

- (CGSize)collectionViewContentSize {
    return self.collectionView.bounds.size;
}

#pragma mark - getter
- (NSMutableArray *)layoutAttributes {
    if (!_layoutAttributes) {
        _layoutAttributes = [NSMutableArray array];
    }
    return _layoutAttributes;
}

@end
