//
//  ViewController.m
//  COXRoundFlowLayout
//
//  Created by ios on 2018/1/16.
//  Copyright © 2018年 ios. All rights reserved.
//

#import "ViewController.h"
#import "COXRoundFlowLayout.h"
#import "COXCollectionViewCell.h"

@interface ViewController ()<UICollectionViewDelegate, UICollectionViewDataSource>
{
    UICollectionView *collection;
}
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    COXRoundFlowLayout *layout = [[COXRoundFlowLayout alloc] init];
    collection = [[UICollectionView alloc] initWithFrame:self.view.bounds collectionViewLayout:layout];
    collection.delegate = self;
    collection.dataSource = self;
    collection.backgroundColor = [UIColor whiteColor];
    [collection registerNib:[UINib nibWithNibName:NSStringFromClass([COXCollectionViewCell class]) bundle:nil] forCellWithReuseIdentifier:@"cell"];
    [self.view addSubview:collection];
}

#pragma mark - delegate
- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section {
    return 8;
}

- (__kindof UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    COXCollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:@"cell" forIndexPath:indexPath];
    if (!cell) {
        cell = [[[NSBundle mainBundle] loadNibNamed:NSStringFromClass([COXCollectionViewCell class]) owner:self options:nil] lastObject];
    }
    cell.labelTxt.text = @(indexPath.item).stringValue;
    return cell;
}

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath {
    NSLog(@" --- > click at %zd item", indexPath.item);
}

@end
